Ruby: include/ruby/internal/core/rregexp.h File Reference

Ruby 3.4.9p82 (2026-03-11 revision 76cca827ab52ab1d346a728f068d5b8da3e2952b)

Data Structures | Macros | Functions
rregexp.h File Reference

Defines struct RRegexp. More...

`#include "ruby/internal/attr/artificial.h"`
`#include "ruby/internal/attr/pure.h"`
`#include "ruby/internal/cast.h"`
`#include "ruby/internal/core/rbasic.h"`
`#include "ruby/internal/core/rstring.h"`
`#include "ruby/internal/value.h"`
`#include "ruby/internal/value_type.h"`

Go to the source code of this file.

## Data Structures
struct | RRegexp
| Ruby's regular expression. More...

## Macros
#define | RREGEXP(obj)
| Convenient casting macro.
#define | RREGEXP_PTR(obj)
| Convenient accessor macro.

## Functions
static VALUE | RREGEXP_SRC (VALUE rexp)
| Convenient getter function.
static char * | RREGEXP_SRC_PTR (VALUE rexp)
| Convenient getter function.
static long | RREGEXP_SRC_LEN (VALUE rexp)
| Convenient getter function.
static char * | RREGEXP_SRC_END (VALUE rexp)
| Convenient getter function.

## Detailed Description

Defines struct RRegexp.

Author
  Ruby developers ruby-.nosp@m.core.nosp@m.@ruby.nosp@m.-lan.nosp@m.g.org

Copyright
  This file is a part of the programming language Ruby. Permission is hereby granted, to either redistribute and/or modify this file, provided that the conditions mentioned in the file COPYING are met. Consult the file for details.

Warning
  Symbols prefixed with either RBIMPL or rbimpl are implementation details. Don't take them as canon. They could rapidly appear then vanish. The name (path) of this header file is also an implementation detail. Do not expect it to persist at the place it is now. Developers are free to move it anywhere anytime at will.

Note
  To ruby-core: remember that this header can be possibly recursively included from extension libraries written in C++. Do not expect for instance __VA_ARGS__ is always available. We assume C99 for ruby itself but we don't assume languages of extension libraries. They could be written in C++98.

Definition in file rregexp.h.

## Macro Definition Documentation

## ◆ RREGEXP

#define RREGEXP | ( |  | obj | ) |

Value:
RBIMPL_CAST((struct RRegexp *)(obj))
RRegexp
Ruby's regular expression.
Definition rregexp.h:60

Convenient casting macro.

Parameters

  obj | An object, which is in fact an RRegexp.

Returns
  The passed object casted to RRegexp.

Definition at line 37 of file rregexp.h.

Referenced by rb_enc_reg_new(), rb_reg_onig_match(), rb_reg_prepare_re(), and RREGEXP_SRC().

## ◆ RREGEXP_PTR

#define RREGEXP_PTR | ( |  | obj | ) |

Value:
(RREGEXP(obj)->ptr)
RREGEXP
#define RREGEXP(obj)
Convenient casting macro.
Definition rregexp.h:37

Convenient accessor macro.

Parameters

  obj | An object, which is in fact an RRegexp.

Returns
  The passed object's pattern buffer.

Definition at line 45 of file rregexp.h.

Referenced by rb_reg_onig_match(), rb_reg_options(), rb_reg_prepare_re(), and rb_reg_regsub().

## Function Documentation

## ◆ RREGEXP_SRC()

VALUE RREGEXP_SRC | ( | VALUE | rexp | ) |
| inlinestatic

Convenient getter function.

Parameters

  [in] | rexp | The regular expression in question.

Returns
  The source code of the regular expression.

Precondition
  rexp must be of RRegexp.

Definition at line 103 of file rregexp.h.

Referenced by rb_reg_prepare_re(), RREGEXP_SRC(), RREGEXP_SRC_END(), RREGEXP_SRC_LEN(), and RREGEXP_SRC_PTR().

## ◆ RREGEXP_SRC_END()

char * RREGEXP_SRC_END | ( | VALUE | rexp | ) |
| inlinestatic

Convenient getter function.

Parameters

  [in] | rexp | The regular expression in question.

Returns
  The end of the source code of the regular expression.

Precondition
  rexp must be of RRegexp.

Definition at line 163 of file rregexp.h.

Referenced by RREGEXP_SRC_END().

## ◆ RREGEXP_SRC_LEN()

long RREGEXP_SRC_LEN | ( | VALUE | rexp | ) |
| inlinestatic

Convenient getter function.

Parameters

  [in] | rexp | The regular expression in question.

Returns
  The length of the source code of the regular expression.

Precondition
  rexp must be of RRegexp.

Definition at line 144 of file rregexp.h.

Referenced by rb_reg_regcomp(), and RREGEXP_SRC_LEN().

## ◆ RREGEXP_SRC_PTR()

char * RREGEXP_SRC_PTR | ( | VALUE | rexp | ) |
| inlinestatic

Convenient getter function.

Parameters

  [in] | rexp | The regular expression in question.

Returns
  The source code of the regular expression, in C's string.

Precondition
  rexp must be of RRegexp.

Definition at line 125 of file rregexp.h.

Referenced by rb_reg_regcomp(), and RREGEXP_SRC_PTR().